diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -663,474 +758,831 @@
           PC.W);
     }
 #endif
-    
-    if(mapper)
-      (*mapperRAM)(address, value);
+
+    // Is that a correct fix ??? (it used to be 'if (mapper)')...
+    if(mapperRAM)
+        (*mapperRAM)(address, value);
     return;
   }
-  
+
+
   if(address < 0xfe00) {
     gbMemoryMap[address>>12][address & 0x0fff] = value;
     return;
   }
-  
-  if(address < 0xff00) {
+
+  // OAM not accessible during mode 2 & 3.
+  if(address < 0xfea0)
+  {
+      if (((gbHardware & 0xa) && ((gbLcdMode | gbLcdModeDelayed) &2)) ||
+          ((gbHardware & 5) && (((gbLcdModeDelayed == 2) &&
+          (gbLcdTicksDelayed<=GBLCD_MODE_2_CLOCK_TICKS)) ||
+          (gbLcdModeDelayed == 3))))
+      return;
+    else
+    {
+      gbMemory[address] = value;
+      return;
+    }
+  }
+
+
+
+  if((address > 0xfea0) && (address < 0xff00)){ // GBC allows reading/writing to that area
     gbMemory[address] = value;
     return;
-  }
-  
+  }   
+
   switch(address & 0x00ff) {
-  case 0x00: {
-    gbMemory[0xff00] = ((gbMemory[0xff00] & 0xcf) |
-                      (value & 0x30));
-    if(gbSgbMode) {
-      gbSgbDoBitTransfer(value);
+
+    case 0x00: {
+      gbMemory[0xff00] = ((gbMemory[0xff00] & 0xcf) |
+                        (value & 0x30) | 0xc0);
+      if(gbSgbMode) {
+        gbSgbDoBitTransfer(value);
+      }
+      return;
     }
-    
-    return;
-  }
 
-  case 0x01: {
-    gbMemory[0xff01] = value;
-    return;
-  }
+    case 0x01: {
+      gbMemory[0xff01] = value;
+      return;
+    }
     
-  // serial control
-  case 0x02: {
-    gbSerialOn = (value & 0x80);
-    gbMemory[0xff02] = value;    
-    if(gbSerialOn) {
-      gbSerialTicks = GBSERIAL_CLOCK_TICKS;
+    // serial control
+    case 0x02: {
+      gbSerialOn = (value & 0x80);
+      gbMemory[0xff02] = value;    
+      if(gbSerialOn) {
+        gbSerialTicks = GBSERIAL_CLOCK_TICKS;
 #ifdef LINK_EMULATION
-      if(linkConnected) {
-        if(value & 1) {
-          linkSendByte(0x100|gbMemory[0xFF01]);
-          Sleep(5);
+        if(linkConnected) {
+          if(value & 1) {
+            linkSendByte(0x100|gbMemory[0xFF01]);
+            Sleep(5);
+          }
         }
-      }
 #endif
-    }
+      }
 
-    gbSerialBits = 0;
-    return;
-  }
+      gbSerialBits = 0;
+      return;
+    }
   
-  // DIV register resets on any write
-  case 0x04: {
-    register_DIV = 0;
-    return;
-  }
-  case 0x05:
-    register_TIMA = value;
-    return;
+    case 0x04: {
+    // DIV register resets on any write
+    // (not totally perfect, but better than nothing)
+      gbMemory[0xff04] = register_DIV = 0;
+      gbDivTicks = GBDIV_CLOCK_TICKS;
+     // Another weird timer 'bug' :
+     // Writing to DIV register resets the internal timer,
+     // and can also increase TIMA/trigger an interrupt
+     // in some cases...
+      if (gbTimerOn && !(gbInternalTimer & (gbTimerClockTicks>>1)))
+      {
+        gbMemory[0xff05] = ++register_TIMA;
+        if(register_TIMA == 0) {
+          // timer overflow!
+            
+          // reload timer modulo
+          gbMemory[0xff05] = register_TIMA = register_TMA;
+              
+          // flag interrupt
+          gbMemory[0xff0f] = register_IF |= 4;
+        }
+      }
+      gbInternalTimer = 0xff;
+      return;
+    }
+    case 0x05:
+      gbMemory[0xff05] = register_TIMA = value;
+      return;
 
-  case 0x06:
-    register_TMA = value;
-    return;
-    
-    // TIMER control
-  case 0x07: {
-    register_TAC = value;
+    case 0x06:
+      gbMemory[0xff06] = register_TMA = value;
+      return;
     
-    gbTimerOn = (value & 4);
-    gbTimerMode = value & 3;
-    //    register_TIMA = register_TMA;
-    switch(gbTimerMode) {
-    case 0:
-      gbTimerClockTicks = gbTimerTicks = GBTIMER_MODE_0_CLOCK_TICKS;
-      break;
-    case 1:
-      gbTimerClockTicks = gbTimerTicks = GBTIMER_MODE_1_CLOCK_TICKS;
-      break;
-    case 2:
-      gbTimerClockTicks = gbTimerTicks = GBTIMER_MODE_2_CLOCK_TICKS;
-      break;
-    case 3:
-      gbTimerClockTicks = gbTimerTicks = GBTIMER_MODE_3_CLOCK_TICKS;
-      break;
-    }
-    return;
-  }
+      // TIMER control
+    case 0x07: {
 
-  case 0x0f: {
-    register_IF = value;
-    gbInterrupt = value;
-    return;
-  }
-  
-  case 0x10:
-  case 0x11:
-  case 0x12:
-  case 0x13:
-  case 0x14:
-  case 0x15:
-  case 0x16:
-  case 0x17:
-  case 0x18:
-  case 0x19:
-  case 0x1a:
-  case 0x1b:
-  case 0x1c:
-  case 0x1d:
-  case 0x1e:
-  case 0x1f:
-  case 0x20:
-  case 0x21:
-  case 0x22:
-  case 0x23:
-  case 0x24:
-  case 0x25:
-  case 0x26: {
-    SOUND_EVENT(address,value);
-    return;
-  }
-  case 0x40: {
-    int lcdChange = (register_LCDC & 0x80) ^ (value & 0x80);
+      gbTimerModeChange = (((value & 3) != (register_TAC&3)) && (value & register_TAC & 4)) ? true : false;
+      gbTimerOnChange = (((value ^ register_TAC) & 4) == 4) ? true : false;
+      
+      gbTimerOn = (value & 4) ? true : false;    
 
-    if(lcdChange) {
-      if(value & 0x80) {
-        gbLcdTicks = GBLCD_MODE_1_CLOCK_TICKS;
-        gbLcdMode = 0;
-        register_STAT &= 0xfc;
-        register_LY = 0x00;
-      } else {
-        gbLcdTicks = 0;
-        gbLcdMode = 0;
-        register_STAT &= 0xfc;
-        register_LY = 0x00;
-      }
-      //      compareLYToLYC();
-    }
-    // don't draw the window if it was not enabled and not being drawn before
-    if(!(register_LCDC & 0x20) && (value & 0x20) && gbWindowLine == -1 &&
-       register_LY > register_WY)
-      gbWindowLine = 144;
+      if (gbTimerOnChange || gbTimerModeChange)
+      {
+        gbTimerMode = value & 3;
 
-    register_LCDC = value;
+        switch(gbTimerMode) {
+          case 0:
+            gbTimerClockTicks = GBTIMER_MODE_0_CLOCK_TICKS;
+            break;
+          case 1:
+            gbTimerClockTicks = GBTIMER_MODE_1_CLOCK_TICKS;
+            break;
+          case 2:
+            gbTimerClockTicks = GBTIMER_MODE_2_CLOCK_TICKS;
+            break;
+          case 3:
+            gbTimerClockTicks = GBTIMER_MODE_3_CLOCK_TICKS;
+            break;
+        }
+      }
 
-    return;
-  }
 
-  // STAT
-  case 0x41: {
-    //register_STAT = (register_STAT & 0x87) |
-    //      (value & 0x7c);
-    register_STAT = (value & 0xf8) | (register_STAT & 0x07); // fix ?
-    // GB bug from Devrs FAQ
-    if(!gbCgbMode && (register_LCDC & 0x80) && gbLcdMode < 2)
-      gbInterrupt |= 2;
-    return;
-  }
+      // This looks weird, but this emulates a bug in which register_TIMA
+      // is increased when writing to register_TAC
+      // (This fixes Korodice's long-delay between menus bug).
+    
+      if (gbTimerOnChange || gbTimerModeChange) 
+      {
+        bool temp = false;
 
-  // SCY
-  case 0x42: {
-    register_SCY = value;
-    return;
-  }
-  
-  // SCX
-  case 0x43: {
-    register_SCX = value;
-    return;
-  }
-  
-  // LY
-  case 0x44: {
-    // read only
-    return;
-  }
+        if ((gbTimerOn  && !gbTimerModeChange)  && (gbTimerMode & 2) &&
+            !(gbInternalTimer & 0x80) && (gbInternalTimer & (gbTimerClockTicks>>1)) &&
+            !(gbInternalTimer & (gbTimerClockTicks>>5)))
+          temp = true;
+        else if ((!gbTimerOn && !gbTimerModeChange && gbTimerOnChange ) &&  ((gbTimerTicks-1) < (gbTimerClockTicks>>1)))
+          temp = true;
+        else if (gbTimerOn && gbTimerModeChange && !gbTimerOnChange)
+        {
+          switch(gbTimerMode & 3)
+          {
+            case 0x00:
+              temp = false;
+              break;
+            case 0x01:
+              if (((gbInternalTimer & 0x82) == 2) && (gbTimerTicks>(clockTicks+1))) 
+                temp = true;
+              break;
+            case 0x02:
+              if (((gbInternalTimer & 0x88) == 0x8) && (gbTimerTicks>(clockTicks+1)))
+                temp = true;
+             break;
+            case 0x03:
+              if (((gbInternalTimer & 0xA0) == 0x20) && (gbTimerTicks>(clockTicks+1)))
+                temp = true;
+              break;
+          }
+        }
 
-  // LYC
-  case 0x45: {
-    register_LYC = value;
-    if((register_LCDC & 0x80)) {
-      gbCompareLYToLYC();
+        if (temp)
+        {
+          gbMemory[0xff05] = ++register_TIMA;
+          if((register_TIMA & 0xff) == 0) {
+            // timer overflow!
+            
+            // reload timer modulo
+            gbMemory[0xff05] = register_TIMA = register_TMA;
+            
+            // flag interrupt
+            gbMemory[0xff0f] = register_IF |= 4;
+          }
+        }
+      }
+      gbMemory[0xff07] = register_TAC = value;
+      return;
     }
-    return;
-  }
-  
-  // DMA!
-  case 0x46: {
-    int source = value * 0x0100;
-
-    gbCopyMemory(0xfe00,
-                 source,
-                 0xa0);
-    register_DMA = value;
-    return;
-  }
-  
-  // BGP
-  case 0x47: {
-    gbBgp[0] = value & 0x03;
-    gbBgp[1] = (value & 0x0c)>>2;
-    gbBgp[2] = (value & 0x30)>>4;
-    gbBgp[3] = (value & 0xc0)>>6;
-    break;
-  }
-  
-  // OBP0
-  case 0x48: {
-    gbObp0[0] = value & 0x03;
-    gbObp0[1] = (value & 0x0c)>>2;
-    gbObp0[2] = (value & 0x30)>>4;
-    gbObp0[3] = (value & 0xc0)>>6;
-    break;
-  }
-
-  // OBP1
-  case 0x49: {
-    gbObp1[0] = value & 0x03;
-    gbObp1[1] = (value & 0x0c)>>2;
-    gbObp1[2] = (value & 0x30)>>4;
-    gbObp1[3] = (value & 0xc0)>>6;
-    break;
-  }
 
-  case 0x4a:
-    register_WY = value;
-    return;
-    
-  case 0x4b:
-    register_WX = value;
-    return;
-  
-    // KEY1
-  case 0x4d: {
-    if(gbCgbMode) {
-      gbMemory[0xff4d] = (gbMemory[0xff4d] & 0x80) | (value & 1);
+    case 0x0f: {
+      gbMemory[0xff0f] = register_IF = value;
+      //gbMemory[0xff0f] = register_IE |= value;
       return;
     }
-  }
-  break;
-    
-  // VBK
-  case 0x4f: {
-    if(gbCgbMode) {
-      value = value & 1;
-      if(value == gbVramBank)
+  
+    case 0x10:
+    case 0x11:
+    case 0x12:
+    case 0x13:
+    case 0x14:
+    case 0x16:
+    case 0x17:
+    case 0x18:
+    case 0x19:
+    case 0x1a:
+    case 0x1b:
+    case 0x1c:
+    case 0x1d:
+    case 0x1e:
+    case 0x20:
+    case 0x21:
+    case 0x22:
+    case 0x23:
+    case 0x24:
+    case 0x25: {
+      if (gbMemory[NR52] & 0x80) {
+        SOUND_EVENT(address,value);
         return;
-      
-      int vramAddress = value * 0x2000;
-      gbMemoryMap[0x08] = &gbVram[vramAddress];
-      gbMemoryMap[0x09] = &gbVram[vramAddress + 0x1000];
-      
-      gbVramBank = value;
-      register_VBK = value;
+      }
     }
-    return;
-  }
-  break;
 
-  // HDMA1
-  case 0x51: {
-    if(gbCgbMode) {
-      if(value > 0x7f && value < 0xa0)
-        value = 0;
-      
-      gbHdmaSource = (value << 8) | (register_HDMA2 & 0xf0);
-      
-      register_HDMA1 = value;
-      return;
-    }
-  }
-  break;
-  
-  // HDMA2
-  case 0x52: {
-    if(gbCgbMode) {
-      value = value & 0xf0;
-      
-      gbHdmaSource = (register_HDMA1 << 8) | (value);
-      
-      register_HDMA2 = value;
+    case 0x26: {
+      SOUND_EVENT(address,value);
       return;
     }
-  }
-  break;
 
-  // HDMA3
-  case 0x53: {
-    if(gbCgbMode) {
-      value = value & 0x1f;
-      gbHdmaDestination = (value << 8) | (register_HDMA4 & 0xf0);
-      gbHdmaDestination += 0x8000;
-      register_HDMA3 = value;
+    case 0x30:
+    case 0x31:
+    case 0x32:
+    case 0x33:
+    case 0x34:
+    case 0x35:
+    case 0x36:
+    case 0x37:
+    case 0x38:
+    case 0x39:
+    case 0x3a:
+    case 0x3b:
+    case 0x3c:
+    case 0x3d:
+    case 0x3e:
+    case 0x3f: {
+      gbMemory[address] = value;
       return;
     }
-  }
-  break;
+
+    case 0x40: {
+      int lcdChange = (register_LCDC & 0x80) ^ (value & 0x80);
+
+      // don't draw the window if it was not enabled and not being drawn before
+      if(!(register_LCDC & 0x20) && (value & 0x20) && gbWindowLine == -1 &&
+         register_LY > register_WY)
+        gbWindowLine = 146;
+      // 007 fix : don't draw the first window's 1st line if it's enable 'too late'
+      // (ie. if register_LY == register_WY when enabling it)
+      // and move it to the next line
+      else if (!(register_LCDC & 0x20) && (value & 0x20) && (register_LY == register_WY))
+        gbWindowLine = -2;
+
+
+      gbMemory[0xff40] = register_LCDC = value;
+
+
+      if(lcdChange) {
+        if((value & 0x80) && (!register_LCDCBusy)) {
+
+        //  if (!gbWhiteScreen && !gbSgbMask)
+
+          //  systemDrawScreen();
+
+
+
+          gbRegisterLYLCDCOffOn = (register_LY + 144) % 154;
+
+          gbLcdTicks = GBLCD_MODE_2_CLOCK_TICKS - (gbSpeed ? 2 : 1);
+          gbLcdTicksDelayed = GBLCD_MODE_2_CLOCK_TICKS - (gbSpeed ? 1 : 0);
+          gbLcdLYIncrementTicks = GBLY_INCREMENT_CLOCK_TICKS - (gbSpeed ? 2 : 1);
+          gbLcdLYIncrementTicksDelayed = GBLY_INCREMENT_CLOCK_TICKS - (gbSpeed ? 1 : 0);
+          gbLcdMode = 2;
+          gbLcdModeDelayed = 2;
+          gbMemory[0xff41] = register_STAT = (register_STAT & 0xfc) | 2;
+          gbMemory[0xff44] = register_LY = 0x00;
+          gbInt48Signal = 0;
+          gbLYChangeHappened = false;
+          gbLCDChangeHappened = false;
+          gbWindowLine = 146;
+          oldRegister_WY = 146;
+
+          // Fix for Namco Gallery Vol.2
+          // (along with updating register_LCDC at the start of 'case 0x40') :
+          if(register_STAT & 0x20)
+          {
+            // send LCD interrupt only if no interrupt 48h signal...
+            if (!gbInt48Signal)
+            {
+              gbMemory[0xff0f] = register_IF |= 2;
+            }
+            gbInt48Signal |= 4;
+          }
+          gbCompareLYToLYC();
+
+        } else {
   
-  // HDMA4
-  case 0x54: {
-    if(gbCgbMode) {
-      value = value & 0xf0;
-      gbHdmaDestination = ((register_HDMA3 & 0x1f) << 8) | value;
-      gbHdmaDestination += 0x8000;
-      register_HDMA4 = value;
+          register_LCDCBusy = clockTicks+6;
+
+          //used to update the screen with white lines when it's off.
+          //(it looks strange, but it's pretty accurate)
+
+          gbWhiteScreen = 0;
+
+          gbScreenTicks = ((150-register_LY)*GBLY_INCREMENT_CLOCK_TICKS +
+                          (49<<(gbSpeed ? 1 : 0)));
+
+          // disable the screen rendering
+          gbScreenOn = false;
+          gbLcdTicks = 0;
+          gbLcdMode = 0;
+          gbLcdModeDelayed = 0;
+          gbMemory[0xff41] = register_STAT &= 0xfc;
+          gbInt48Signal = 0;
+        }
+      }
       return;
     }
-  }
-  break;
-  
-  // HDMA5
-  case 0x55: {
-    if(gbCgbMode) {
-      gbHdmaBytes = 16 + (value & 0x7f) * 16;
-      if(gbHdmaOn) {
-        if(value & 0x80) {
-          register_HDMA5 = (value & 0x7f);
-        } else {
-          register_HDMA5 = 0xff;
-          gbHdmaOn = 0;
+
+    // STAT
+    case 0x41: {
+      //register_STAT = (register_STAT & 0x87) |
+      //      (value & 0x7c);
+      gbMemory[0xff41] = register_STAT = (value & 0xf8) | (register_STAT & 0x07); // fix ?
+      // GB bug from Devrs FAQ
+      // Corrected : it happens if Lcd Mode<2, but also if LY == LYC whatever
+      // Lcd Mode is, and if !gbInt48Signal in all cases. The screen being off
+      // doesn't matter (the bug will still happen).
+      // That fixes 'Satoru Nakajima - F-1 Hero' crash bug.
+
+      if((gbHardware & 5) && (((!gbInt48Signal) && (gbLcdMode<2) && (register_LCDC & 0x80)) ||
+          (register_LY == register_LYC)))
+      {
+        gbMemory[0xff0f] = register_IF |=2;
+      }
+    
+      gbInt48Signal &= ((register_STAT>>3) & 0xF);
+
+      if((register_LCDC & 0x80)) {
+        if ((register_STAT & 0x08) && (gbLcdMode == 0))
+        {
+          if (!gbInt48Signal)
+          {
+            gbMemory[0xff0f] = register_IF |=2;
+          }
+          gbInt48Signal |= 1;
         }
-      } else {
-        if(value & 0x80) {
-          gbHdmaOn = 1;
-          register_HDMA5 = value & 0x7f;
-          if(gbLcdMode == 0)
-            gbDoHdma();
-        } else {
-          // we need to take the time it takes to complete the transfer into
-          // account... according to GB DEV FAQs, the setup time is the same
-          // for single and double speed, but the actual transfer takes the
-          // same time
-          if(gbSpeed)
-            gbDmaTicks = 231 + 16 * (value & 0x7f);
-          else
-            gbDmaTicks = 231 + 8 * (value & 0x7f);
-          gbCopyMemory(gbHdmaDestination,
-                       gbHdmaSource,
-                       gbHdmaBytes);
-          gbHdmaDestination += gbHdmaBytes;
-          gbHdmaSource += gbHdmaBytes;
-          
-          register_HDMA3 = ((gbHdmaDestination - 0x8000) >> 8) & 0x1f;
-          register_HDMA4 = gbHdmaDestination & 0xf0;
-          register_HDMA1 = (gbHdmaSource >> 8) & 0xff;
-          register_HDMA2 = gbHdmaSource & 0xf0;
+        if ((register_STAT & 0x10) && (gbLcdMode == 1))
+        {
+          if (!gbInt48Signal)
+          {
+            gbMemory[0xff0f] = register_IF |=2;
+          }
+          gbInt48Signal |= 2;
+        }
+        if ((register_STAT & 0x20) && (gbLcdMode == 2))
+        {
+          if (!gbInt48Signal)
+          {
+            gbMemory[0xff0f] = register_IF |=2;
+          }
+          gbInt48Signal |= 4;
         }
+        gbCompareLYToLYC();
+
+        gbMemory[0xff0f] = register_IF;
+        gbMemory[0xff41] = register_STAT;
+    
       }
       return;
     }
-  }
-  break;
-  
-  // BCPS
-  case 0x68: {
-     if(gbCgbMode) {
-      int paletteIndex = (value & 0x3f) >> 1;
-      int paletteHiLo   = (value & 0x01);
-      
-      gbMemory[0xff68] = value;
-      gbMemory[0xff69] = (paletteHiLo ?
-                        (gbPalette[paletteIndex] >> 8) :
-                        (gbPalette[paletteIndex] & 0x00ff));
-      return;
-    }
-  }
-  break;
-  
-  // BCPD
-  case 0x69: {
-    if(gbCgbMode) {
-      int v = gbMemory[0xff68];      
-      int paletteIndex = (v & 0x3f) >> 1;
-      int paletteHiLo  = (v & 0x01);
-      gbMemory[0xff69] = value;
-      gbPalette[paletteIndex] = (paletteHiLo ?
-                                 ((value << 8) | (gbPalette[paletteIndex] & 0xff)) :
-                                 ((gbPalette[paletteIndex] & 0xff00) | (value))) & 0x7fff;
-                                        
-      if(gbMemory[0xff68] & 0x80) {
-        int index = ((gbMemory[0xff68] & 0x3f) + 1) & 0x3f;
-        
-        gbMemory[0xff68] = (gbMemory[0xff68] & 0x80) | index;
-        
-        gbMemory[0xff69] = (index & 1 ?
-                          (gbPalette[index>>1] >> 8) :
-                          (gbPalette[index>>1] & 0x00ff));
-        
+
+    // SCY
+    case 0x42: {
+      int temp = -1;
+
+      if ((gbLcdMode == 3) || (gbLcdModeDelayed == 3))
+        temp = ((GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS) - 
+               gbLcdLYIncrementTicks);
+
+      if (temp >=0)
+      {
+        for (int i=temp<<(gbSpeed ? 1 : 2);i<300;i++)
+          if (temp < 300)
+            gbSCYLine[i] = value;
       }
+      
+      else 
+        memset(gbSCYLine, value, sizeof(gbSCYLine));
+
+      gbMemory[0xff42] = register_SCY = value;
       return;
     }
-  }
-  break;
   
-  // OCPS 
-  case 0x6a: {
-    if(gbCgbMode) {
-      int paletteIndex = (value & 0x3f) >> 1;
-      int paletteHiLo   = (value & 0x01);
-      
-      paletteIndex += 32;
+    // SCX
+    case 0x43: {
+      int temp = -1;
+
+      if (gbLcdModeDelayed == 3)
+        temp = ((GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS) - 
+               gbLcdLYIncrementTicksDelayed);
+
+      if (temp >=0)
+      {
+        for (int i=temp<<(gbSpeed ? 1 : 2);i<300;i++)
+          if (temp < 300)
+            gbSCXLine[i] = value;
+      }
       
-      gbMemory[0xff6a] = value;
-      gbMemory[0xff6b] = (paletteHiLo ?
-                        (gbPalette[paletteIndex] >> 8) :
-                        (gbPalette[paletteIndex] & 0x00ff));
+      else 
+        memset(gbSCXLine, value, sizeof(gbSCXLine));
+
+      gbMemory[0xff43] = register_SCX = value;
       return;
     }
-  }
-  break;
   
-  // OCPD
-  case 0x6b: {
-    if(gbCgbMode) {
-      int v = gbMemory[0xff6a];      
-      int paletteIndex = (v & 0x3f) >> 1;
-      int paletteHiLo  = (v & 0x01);
-      
-      paletteIndex += 32;
-      
-      gbMemory[0xff6b] = value;
-      gbPalette[paletteIndex] = (paletteHiLo ?
-                                 ((value << 8) | (gbPalette[paletteIndex] & 0xff)) :
-                                 ((gbPalette[paletteIndex] & 0xff00) | (value))) & 0x7fff;
-      if(gbMemory[0xff6a] & 0x80) {
-        int index = ((gbMemory[0xff6a] & 0x3f) + 1) & 0x3f;
-        
-        gbMemory[0xff6a] = (gbMemory[0xff6a] & 0x80) | index;
-        
-        gbMemory[0xff6b] = (index & 1 ?
-                          (gbPalette[(index>>1) + 32] >> 8) :
-                          (gbPalette[(index>>1) + 32] & 0x00ff));
-        
-      }      
+    // LY
+    case 0x44: {
+      // read only
       return;
     }
-  }
-  break;
-  
-  // SVBK
-  case 0x70: {
-    if(gbCgbMode) {
-      value = value & 7;
-
-      int bank = value;
-      if(value == 0)
-        bank = 1;
 
-      if(bank == gbWramBank)
+    // LYC
+    case 0x45: {
+      if (register_LYC != value)
+      {
+        gbMemory[0xff45] = register_LYC = value;
+        if(register_LCDC & 0x80) {
+          gbCompareLYToLYC();
+        }
+      }
+      return;
+    }
+  
+    // DMA!
+    case 0x46: {
+      int source = value * 0x0100;
+
+      gbCopyMemory(0xfe00,
+                   source,
+                   0xa0);
+      gbMemory[0xff46] = register_DMA = value;
+      return;
+    }
+  
+    // BGP
+    case 0x47: {
+
+      int temp = -1;
+
+      gbMemory[0xff47] = value;
+
+      if (gbLcdModeDelayed == 3)
+        temp = ((GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS) - 
+               gbLcdLYIncrementTicksDelayed);
+
+      if (temp >=0)
+      {
+        for (int i=temp<<(gbSpeed ? 1 : 2);i<300;i++)
+          if (temp < 300)
+            gbBgpLine[i] = value;
+      }
+      else
+        memset(gbBgpLine,value,sizeof(gbBgpLine));
+
+      gbBgp[0] = value & 0x03;
+      gbBgp[1] = (value & 0x0c)>>2;
+      gbBgp[2] = (value & 0x30)>>4;
+      gbBgp[3] = (value & 0xc0)>>6;
+      break;
+    }
+  
+    // OBP0
+    case 0x48: {
+      int temp = -1;
+
+      gbMemory[0xff48] = value;
+
+      if (gbLcdModeDelayed == 3)
+        temp = ((GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS) - 
+               gbLcdLYIncrementTicksDelayed);
+
+      if (temp >=0)
+      {
+        for (int i=temp<<(gbSpeed ? 1 : 2);i<300;i++)
+          if (temp < 300)
+            gbObp0Line[i] = value;
+      }
+      else
+        memset(gbObp0Line,value,sizeof(gbObp0Line));
+
+      gbObp0[0] = value & 0x03;
+      gbObp0[1] = (value & 0x0c)>>2;
+      gbObp0[2] = (value & 0x30)>>4;
+      gbObp0[3] = (value & 0xc0)>>6;
+      break;
+    }
+
+    // OBP1
+    case 0x49: {
+      int temp = -1;
+
+      gbMemory[0xff49] = value;
+
+      if (gbLcdModeDelayed == 3)
+        temp = ((GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS) - 
+               gbLcdLYIncrementTicksDelayed);
+
+      if (temp >=0)
+      {
+        for (int i=temp<<(gbSpeed ? 1 : 2);i<300;i++)
+          if (temp < 300)
+            gbObp1Line[i] = value;
+      }
+      else
+        memset(gbObp1Line,value,sizeof(gbObp1Line));
+
+      gbObp1[0] = value & 0x03;
+      gbObp1[1] = (value & 0x0c)>>2;
+      gbObp1[2] = (value & 0x30)>>4;
+      gbObp1[3] = (value & 0xc0)>>6;
+      break;
+    }
+
+    // WY
+    case 0x4a:
+      gbMemory[0xff4a] = register_WY = value;
+      if ((register_LY <= register_WY) && ((gbWindowLine < 0) || (gbWindowLine>=144)))
+      {
+          gbWindowLine = -1;
+          oldRegister_WY = register_WY;
+      }
+      return;
+
+    // WX
+    case 0x4b:
+      gbMemory[0xff4b] = register_WX = value;
+      return;
+  
+    // KEY1
+    case 0x4d: {
+      if(gbCgbMode) {
+        gbMemory[0xff4d] = (gbMemory[0xff4d] & 0x80) | (value & 1) | 0x7e;
         return;
+      }
+    }
+    break;
+    
+    // VBK
+    case 0x4f: {
+      if(gbCgbMode) {
+        value = value & 1;
+        if(value == gbVramBank)
+          return;
       
-      int wramAddress = bank * 0x1000;
-      gbMemoryMap[0x0d] = &gbWram[wramAddress];
+        int vramAddress = value * 0x2000;
+        gbMemoryMap[0x08] = &gbVram[vramAddress];
+        gbMemoryMap[0x09] = &gbVram[vramAddress + 0x1000];
       
-      gbWramBank = bank;
-      register_SVBK = value;
+        gbVramBank = value;
+        register_VBK = value;
+      }
       return;
     }
-  }
-  break;
+    break;
+
+    // BOOTROM disable register (also gbCgbMode enabler if value & 0x10 ?)
+    case 0x50 :
+    {
+      if (useBios && inBios && !skipBios && (value & 1))
+      {
+        gbMemoryMap[0x00] = &gbRom[0x0000];
+        memcpy ((u8 *)(gbRom+0x100), (u8 *)(gbMemory + 0x100), 0xF00);
+        inBios = false;
+      }
+    }
+
+    // HDMA1
+    case 0x51: {
+      if(gbCgbMode) {
+        if(value > 0x7f && value < 0xa0)
+          value = 0;
+      
+        gbHdmaSource = (value << 8) | (gbHdmaSource & 0xf0);
+      
+        register_HDMA1 = value;
+        return;
+      }
+    }
+    break;
   
-  case 0xff: {
-    register_IE = value;
-    register_IF &= value;
-    return;
+    // HDMA2
+    case 0x52: {
+      if(gbCgbMode) {
+        value = value & 0xf0;
+      
+        gbHdmaSource = (gbHdmaSource & 0xff00) | (value);
+      
+        register_HDMA2 = value;
+        return;
+      }
+    }
+    break;
+
+    // HDMA3
+    case 0x53: {
+      if(gbCgbMode) {
+        value = value & 0x1f;
+        gbHdmaDestination = (value << 8) | (gbHdmaDestination & 0xf0);
+        gbHdmaDestination |= 0x8000;
+        register_HDMA3 = value;
+        return;
+      }
+    }
+    break;
+  
+    // HDMA4
+    case 0x54: {
+      if(gbCgbMode) {
+        value = value & 0xf0;
+        gbHdmaDestination = (gbHdmaDestination & 0x1f00) | value;
+        gbHdmaDestination |= 0x8000;
+        register_HDMA4 = value;
+        return;
+      }
+    }
+    break;
+  
+    // HDMA5
+    case 0x55: {
+
+      if(gbCgbMode) {
+        gbHdmaBytes = 16 + (value & 0x7f) * 16;
+        if(gbHdmaOn) {
+          if(value & 0x80) {
+            gbMemory[0xff55] = register_HDMA5 = (value & 0x7f);
+          } else {
+            register_HDMA5 = 0xff;
+            gbHdmaOn = 0;
+          }
+        } else {
+          if(value & 0x80) {
+            gbHdmaOn = 1;
+            gbMemory[0xff55] = register_HDMA5 = value & 0x7f;
+            if(gbLcdModeDelayed == 0)
+              gbDoHdma();
+          } else {
+            // we need to take the time it takes to complete the transfer into
+            // account... according to GB DEV FAQs, the setup time is the same
+            // for single and double speed, but the actual transfer takes the
+            // same time
+            if(gbSpeed)
+              gbDmaTicks = 2+16 * ((value & 0x7f) +1);
+            else
+              gbDmaTicks = 1+8 * ((value & 0x7f)+1);
+
+            gbCopyMemory((gbHdmaDestination & 0x1ff0) | 0x8000,
+                         gbHdmaSource & 0xfff0,
+                         gbHdmaBytes);
+            gbHdmaDestination += gbHdmaBytes;
+            gbHdmaSource += gbHdmaBytes;
+          
+            gbMemory[0xff51] = register_HDMA1 = 0xff;// = (gbHdmaSource >> 8) & 0xff;
+            gbMemory[0xff52] = register_HDMA2 = 0xff;// = gbHdmaSource & 0xf0;
+            gbMemory[0xff53] = register_HDMA3 = 0xff;// = ((gbHdmaDestination - 0x8000) >> 8) & 0x1f;
+            gbMemory[0xff54] = register_HDMA4 = 0xff;// = gbHdmaDestination & 0xf0;
+            gbMemory[0xff55] = register_HDMA5 = 0xff;
+          }
+        }
+        return;
+      }
+    }
+    break;
+  
+    // BCPS
+    case 0x68: {
+       if(gbCgbMode) {
+        int paletteIndex = (value & 0x3f) >> 1;
+        int paletteHiLo   = (value & 0x01);
+        
+        gbMemory[0xff68] = value;
+        
+        gbMemory[0xff69] = (paletteHiLo ?
+                           (gbPalette[paletteIndex] >> 8) :
+                           (gbPalette[paletteIndex] & 0x00ff));
+        return;
+      }
+    }
+    break;
+  
+    // BCPD
+    case 0x69: {
+      if(gbCgbMode) {
+        int v = gbMemory[0xff68];      
+        int paletteIndex = (v & 0x3f) >> 1;
+        int paletteHiLo  = (v & 0x01);
+
+        // No access to gbPalette during mode 3 (Color Panel Demo)
+        if (((gbLcdModeDelayed != 3) && (!((gbLcdMode == 0) && (gbLcdTicks>=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-1)))) && (!gbSpeed)) ||
+           (gbSpeed && ((gbLcdMode == 1) || (gbLcdMode == 2) ||
+           ((gbLcdMode == 3) && (gbLcdTicks>(GBLCD_MODE_3_CLOCK_TICKS-2))) ||
+           ((gbLcdMode == 0) && (gbLcdTicks<=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-2))))))
+        {
+          gbMemory[0xff69] = value;
+          gbPalette[paletteIndex] = (paletteHiLo ?
+                                   ((value << 8) | (gbPalette[paletteIndex] & 0xff)) :
+                                    ((gbPalette[paletteIndex] & 0xff00) | (value))) & 0x7fff;
+        }
+
+                                        
+        if(gbMemory[0xff68] & 0x80) {
+          int index = ((gbMemory[0xff68] & 0x3f) + 1) & 0x3f;
+        
+          gbMemory[0xff68] = (gbMemory[0xff68] & 0x80) | index;
+          gbMemory[0xff69] = (index & 1 ?
+                             (gbPalette[index>>1] >> 8) :
+                             (gbPalette[index>>1] & 0x00ff));
+        }
+        return;
+      }
+    }
+    break;
+  
+    // OCPS 
+    case 0x6a: {
+      if(gbCgbMode) {
+        int paletteIndex = (value & 0x3f) >> 1;
+        int paletteHiLo   = (value & 0x01);
+      
+        paletteIndex += 32;
+
+        gbMemory[0xff6a] = value;
+
+        gbMemory[0xff6b] = (paletteHiLo ?
+                           (gbPalette[paletteIndex] >> 8) :
+                           (gbPalette[paletteIndex] & 0x00ff));
+        return;
+      }
+    }
+    break;
+  
+    // OCPD
+    case 0x6b: {
+
+      if(gbCgbMode) {
+        int v = gbMemory[0xff6a];      
+        int paletteIndex = (v & 0x3f) >> 1;
+        int paletteHiLo  = (v & 0x01);
+      
+        paletteIndex += 32;
+      
+        // No access to gbPalette during mode 3 (Color Panel Demo)
+        if (((gbLcdModeDelayed != 3) && (!((gbLcdMode == 0) && (gbLcdTicks>=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-1)))) && (!gbSpeed)) ||
+           (gbSpeed && ((gbLcdMode == 1) || (gbLcdMode == 2) ||
+           ((gbLcdMode == 3) && (gbLcdTicks>(GBLCD_MODE_3_CLOCK_TICKS-2))) ||
+           ((gbLcdMode == 0) && (gbLcdTicks<=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-2))))))
+        {
+          gbMemory[0xff6b] = value;
+          gbPalette[paletteIndex] = (paletteHiLo ?
+                                    ((value << 8) | (gbPalette[paletteIndex] & 0xff)) :
+                                    ((gbPalette[paletteIndex] & 0xff00) | (value))) & 0x7fff;
+        }
+
+        if(gbMemory[0xff6a] & 0x80) {
+          int index = ((gbMemory[0xff6a] & 0x3f) + 1) & 0x3f;
+        
+          gbMemory[0xff6a] = (gbMemory[0xff6a] & 0x80) | index;
+        
+          gbMemory[0xff6b] = (index & 1 ?
+                             (gbPalette[(index>>1) + 32] >> 8) :
+                             (gbPalette[(index>>1) + 32] & 0x00ff));
+        }      
+        return;
+      }
+    }
+    break;
+
+    case 0x6c: {
+      gbMemory[0xff6c] = 0xfe | value;
+      return;
+    }
+
+  
+    // SVBK
+    case 0x70: {
+      if(gbCgbMode) {
+        value = value & 7;
+
+        int bank = value;
+        if(value == 0)
+          bank = 1;
+  
+        if(bank == gbWramBank)
+          return;
+      
+        int wramAddress = bank * 0x1000;
+        gbMemoryMap[0x0d] = &gbWram[wramAddress];
+      
+        gbWramBank = bank;
+        gbMemory[0xff70] = register_SVBK = value;
+        return;
+      }
+    }
+
+    case 0x75:{
+      gbMemory[0xff75] = 0x8f | value;
+      return;
+    }
+  
+    case 0xff: {
+      gbMemory[0xffff] = register_IE = value;
+      return;
+    }
   }
+
+  if(address < 0xff80)
+  {
+    gbMemory[address] = value;
+    return;
   }
-  
+
   gbMemory[address] = value;
 }
 
